- name: Re-Login to keycloak
  uri:
    method: POST
    url: "https://idm.{{ DOMAIN }}/auth/realms/master/protocol/openid-connect/token"
    return_content: yes
    body_format: form-urlencoded
    body:
        grant_type: "password"
        client_id: "admin-cli"
        username: "{{ ADMIN_USERNAME }}"
        password: "{{ ADMIN_PASSWORD }}"
    status_code: 200
  register: keycloak_login

- name: Get users
  uri:
    method: GET
    url: "https://idm.{{ DOMAIN }}/auth/admin/realms/{{ inv_idm.keycloak.realm_name }}/users"
    return_content: yes
    headers:
      Accept: application/json
      Authorization: Bearer {{ keycloak_login.json.access_token }}
    status_code: 200
  register: users

- name: Print the gateway for each host when defined
  ansible.builtin.debug:
    msg: "{{ users }}"

- name: "Set platform user id."
  set_fact:
    platform_user_id: "{{ users.json | json_query(query) }}"
  vars:
    query: "[?username== '{{ ADMIN_USERNAME }}'].id | [0]"

- name: Get roles CKAN
  uri:
    method: GET
    url: "https://idm.{{ DOMAIN }}/auth/admin/realms/{{ inv_idm.keycloak.realm_name }}/clients/{{ client_id_ckan }}/roles"
    return_content: yes
    headers:
      Accept: application/json
      Authorization: Bearer {{ keycloak_login.json.access_token }}
    status_code: 200
  register: ckan_roles

- name: "Set role id CKAN."
  set_fact:
    ckan_role_id: "{{ ckan_roles.json | json_query(query) }}"
  vars:
    query: "[?name== 'ckanAdmin'].id | [0]"

- name: Assign Roles to Platform Admin (CKAN)
  uri:
    method: POST
    url: "https://idm.{{ DOMAIN }}/auth/admin/realms/{{ inv_idm.keycloak.realm_name }}/users/{{ platform_user_id }}/role-mappings/clients/{{ client_id_ckan }}"
    return_content: yes
    body_format: json
    body: |
      [{
        "id": "{{ ckan_role_id }}",
        "name": "ckanAdmin",
        "composite": false,
        "clientRole": true,
        "containerId": "{{ client_id_ckan }}"
      }]
    headers:
      Accept: application/json
      Authorization: Bearer {{ keycloak_login.json.access_token }}
    status_code: 204